Jonathan Nieder | 11d6214 | 2013-11-25 13:03:52 -0800 | [diff] [blame] | 1 | # This shell scriplet is meant to be included by other shell scripts |
| 2 | # to set up some variables pointing at the normal git directories and |
| 3 | # a few helper shell functions. |
Linus Torvalds | b33e966 | 2005-07-08 10:57:21 -0700 | [diff] [blame] | 4 | |
Junio C Hamano | 365527a | 2005-09-12 19:47:07 -0700 | [diff] [blame] | 5 | # Having this variable in your environment would break scripts because |
Junio C Hamano | e598c51 | 2007-09-15 16:32:23 -0700 | [diff] [blame] | 6 | # you would cause "cd" to be taken to unexpected places. If you |
Junio C Hamano | 365527a | 2005-09-12 19:47:07 -0700 | [diff] [blame] | 7 | # like CDPATH, define it for your interactive shell sessions without |
| 8 | # exporting it. |
Junio C Hamano | 785063e | 2012-08-08 12:08:17 -0700 | [diff] [blame] | 9 | # But we protect ourselves from such a user mistake nevertheless. |
Junio C Hamano | 365527a | 2005-09-12 19:47:07 -0700 | [diff] [blame] | 10 | unset CDPATH |
| 11 | |
Junio C Hamano | 393050c | 2012-12-07 14:31:52 -0800 | [diff] [blame] | 12 | # Similarly for IFS, but some shells (e.g. FreeBSD 7.2) are buggy and |
| 13 | # do not equate an unset IFS with IFS with the default, so here is |
| 14 | # an explicit SP HT LF. |
| 15 | IFS=' |
| 16 | ' |
Junio C Hamano | 785063e | 2012-08-08 12:08:17 -0700 | [diff] [blame] | 17 | |
Junio C Hamano | 61dbb3c | 2009-06-08 09:41:49 -0700 | [diff] [blame] | 18 | git_broken_path_fix () { |
| 19 | case ":$PATH:" in |
| 20 | *:$1:*) : ok ;; |
| 21 | *) |
| 22 | PATH=$( |
| 23 | SANE_TOOL_PATH="$1" |
| 24 | IFS=: path= sep= |
| 25 | set x $PATH |
| 26 | shift |
| 27 | for elem |
| 28 | do |
| 29 | case "$SANE_TOOL_PATH:$elem" in |
| 30 | (?*:/bin | ?*:/usr/bin) |
| 31 | path="$path$sep$SANE_TOOL_PATH" |
| 32 | sep=: |
| 33 | SANE_TOOL_PATH= |
| 34 | esac |
| 35 | path="$path$sep$elem" |
| 36 | sep=: |
| 37 | done |
| 38 | echo "$path" |
| 39 | ) |
| 40 | ;; |
| 41 | esac |
| 42 | } |
| 43 | |
| 44 | # @@BROKEN_PATH_FIX@@ |
Junio C Hamano | 0e0aea5 | 2009-06-05 18:36:15 -0500 | [diff] [blame] | 45 | |
Anders Kaseorg | 1073094 | 2016-10-29 22:10:02 -0400 | [diff] [blame] | 46 | # Source git-sh-i18n for gettext support. |
| 47 | . "$(git --exec-path)/git-sh-i18n" |
| 48 | |
Fredrik Gustafsson | adb231c | 2011-06-09 09:47:02 +0200 | [diff] [blame] | 49 | die () { |
| 50 | die_with_status 1 "$@" |
| 51 | } |
| 52 | |
| 53 | die_with_status () { |
| 54 | status=$1 |
| 55 | shift |
Matthieu Moy | 89b0230 | 2013-08-07 11:26:05 +0200 | [diff] [blame] | 56 | printf >&2 '%s\n' "$*" |
Fredrik Gustafsson | adb231c | 2011-06-09 09:47:02 +0200 | [diff] [blame] | 57 | exit "$status" |
Linus Torvalds | b33e966 | 2005-07-08 10:57:21 -0700 | [diff] [blame] | 58 | } |
| 59 | |
Stephen Boyd | e064c17 | 2009-06-16 15:32:59 -0700 | [diff] [blame] | 60 | GIT_QUIET= |
| 61 | |
| 62 | say () { |
| 63 | if test -z "$GIT_QUIET" |
| 64 | then |
| 65 | printf '%s\n' "$*" |
| 66 | fi |
| 67 | } |
| 68 | |
Pierre Habouzit | bac199b | 2007-11-04 11:30:54 +0100 | [diff] [blame] | 69 | if test -n "$OPTIONS_SPEC"; then |
| 70 | usage() { |
Junio C Hamano | 5d29275 | 2007-12-20 12:58:06 -0800 | [diff] [blame] | 71 | "$0" -h |
| 72 | exit 1 |
Pierre Habouzit | bac199b | 2007-11-04 11:30:54 +0100 | [diff] [blame] | 73 | } |
| 74 | |
Pierre Habouzit | e817e3e | 2007-11-08 10:32:11 +0100 | [diff] [blame] | 75 | parseopt_extra= |
| 76 | [ -n "$OPTIONS_KEEPDASHDASH" ] && |
| 77 | parseopt_extra="--keep-dashdash" |
Nicolas Vigier | 51ba8ce | 2014-02-01 02:17:59 +0000 | [diff] [blame] | 78 | [ -n "$OPTIONS_STUCKLONG" ] && |
| 79 | parseopt_extra="$parseopt_extra --stuck-long" |
Pierre Habouzit | e817e3e | 2007-11-08 10:32:11 +0100 | [diff] [blame] | 80 | |
| 81 | eval "$( |
Junio C Hamano | cbea86f | 2007-11-07 23:04:38 -0800 | [diff] [blame] | 82 | echo "$OPTIONS_SPEC" | |
Pierre Habouzit | e817e3e | 2007-11-08 10:32:11 +0100 | [diff] [blame] | 83 | git rev-parse --parseopt $parseopt_extra -- "$@" || |
| 84 | echo exit $? |
| 85 | )" |
Pierre Habouzit | bac199b | 2007-11-04 11:30:54 +0100 | [diff] [blame] | 86 | else |
Dan Wyand | 7d665f3 | 2014-11-24 18:03:31 -0500 | [diff] [blame] | 87 | dashless=$(basename -- "$0" | sed -e 's/-/ /') |
Pierre Habouzit | bac199b | 2007-11-04 11:30:54 +0100 | [diff] [blame] | 88 | usage() { |
Vasco Almeida | d323c6b | 2016-06-17 20:21:02 +0000 | [diff] [blame] | 89 | die "$(eval_gettext "usage: \$dashless \$USAGE")" |
Pierre Habouzit | bac199b | 2007-11-04 11:30:54 +0100 | [diff] [blame] | 90 | } |
| 91 | |
| 92 | if [ -z "$LONG_USAGE" ] |
| 93 | then |
Vasco Almeida | d323c6b | 2016-06-17 20:21:02 +0000 | [diff] [blame] | 94 | LONG_USAGE="$(eval_gettext "usage: \$dashless \$USAGE")" |
Pierre Habouzit | bac199b | 2007-11-04 11:30:54 +0100 | [diff] [blame] | 95 | else |
Vasco Almeida | d323c6b | 2016-06-17 20:21:02 +0000 | [diff] [blame] | 96 | LONG_USAGE="$(eval_gettext "usage: \$dashless \$USAGE |
Pierre Habouzit | bac199b | 2007-11-04 11:30:54 +0100 | [diff] [blame] | 97 | |
Vasco Almeida | d323c6b | 2016-06-17 20:21:02 +0000 | [diff] [blame] | 98 | $LONG_USAGE")" |
Pierre Habouzit | bac199b | 2007-11-04 11:30:54 +0100 | [diff] [blame] | 99 | fi |
| 100 | |
| 101 | case "$1" in |
Clemens Buchacher | 87182b1 | 2011-10-03 20:21:36 +0200 | [diff] [blame] | 102 | -h) |
Pierre Habouzit | bac199b | 2007-11-04 11:30:54 +0100 | [diff] [blame] | 103 | echo "$LONG_USAGE" |
| 104 | exit |
| 105 | esac |
| 106 | fi |
Fredrik Kuivinen | d025524 | 2005-12-11 10:55:49 +0100 | [diff] [blame] | 107 | |
Junio C Hamano | c3e2d18 | 2013-06-19 10:54:00 -0700 | [diff] [blame] | 108 | # Set the name of the end-user facing command in the reflog when the |
| 109 | # script may update refs. When GIT_REFLOG_ACTION is already set, this |
| 110 | # will not overwrite it, so that a scripted Porcelain (e.g. "git |
| 111 | # rebase") can set it to its own name (e.g. "rebase") and then call |
| 112 | # another scripted Porcelain (e.g. "git am") and a call to this |
| 113 | # function in the latter will keep the name of the end-user facing |
| 114 | # program (e.g. "rebase") in GIT_REFLOG_ACTION, ensuring whatever it |
| 115 | # does will be record as actions done as part of the end-user facing |
| 116 | # operation (e.g. "rebase"). |
| 117 | # |
| 118 | # NOTE NOTE NOTE: consequently, after assigning a specific message to |
| 119 | # GIT_REFLOG_ACTION when calling a "git" command to record a custom |
| 120 | # reflog message, do not leave that custom value in GIT_REFLOG_ACTION, |
| 121 | # after you are done. Other callers of "git" commands that rely on |
| 122 | # writing the default "program name" in reflog expect the variable to |
| 123 | # contain the value set by this function. |
| 124 | # |
| 125 | # To use a custom reflog message, do either one of these three: |
| 126 | # |
| 127 | # (a) use a single-shot export form: |
| 128 | # GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz" \ |
| 129 | # git command-that-updates-a-ref |
| 130 | # |
| 131 | # (b) save the original away and restore: |
| 132 | # SAVED_ACTION=$GIT_REFLOG_ACTION |
| 133 | # GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz" |
| 134 | # git command-that-updates-a-ref |
| 135 | # GIT_REFLOG_ACITON=$SAVED_ACTION |
| 136 | # |
| 137 | # (c) assign the variable in a subshell: |
| 138 | # ( |
| 139 | # GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz" |
| 140 | # git command-that-updates-a-ref |
| 141 | # ) |
Shawn O. Pearce | f947413 | 2006-12-28 02:34:48 -0500 | [diff] [blame] | 142 | set_reflog_action() { |
| 143 | if [ -z "${GIT_REFLOG_ACTION:+set}" ] |
| 144 | then |
| 145 | GIT_REFLOG_ACTION="$*" |
| 146 | export GIT_REFLOG_ACTION |
| 147 | fi |
| 148 | } |
| 149 | |
Adam Roben | ef0c2ab | 2007-07-19 22:09:35 -0700 | [diff] [blame] | 150 | git_editor() { |
Jonathan Nieder | b4479f0 | 2009-10-30 20:42:34 -0500 | [diff] [blame] | 151 | if test -z "${GIT_EDITOR:+set}" |
| 152 | then |
| 153 | GIT_EDITOR="$(git var GIT_EDITOR)" || return $? |
| 154 | fi |
| 155 | |
| 156 | eval "$GIT_EDITOR" '"$@"' |
Adam Roben | ef0c2ab | 2007-07-19 22:09:35 -0700 | [diff] [blame] | 157 | } |
| 158 | |
Jonathan Nieder | f6dff11 | 2010-02-14 23:04:13 -0600 | [diff] [blame] | 159 | git_pager() { |
| 160 | if test -t 1 |
| 161 | then |
| 162 | GIT_PAGER=$(git var GIT_PAGER) |
| 163 | else |
| 164 | GIT_PAGER=cat |
| 165 | fi |
Eric Wong | 995bc22 | 2016-08-04 11:40:25 +0000 | [diff] [blame] | 166 | for vardef in @@PAGER_ENV@@ |
| 167 | do |
| 168 | var=${vardef%%=*} |
| 169 | eval ": \"\${$vardef}\" && export $var" |
| 170 | done |
Jonathan Nieder | f6dff11 | 2010-02-14 23:04:13 -0600 | [diff] [blame] | 171 | |
| 172 | eval "$GIT_PAGER" '"$@"' |
| 173 | } |
| 174 | |
Junio C Hamano | e1622bf | 2009-11-23 15:56:32 -0800 | [diff] [blame] | 175 | sane_grep () { |
Junio C Hamano | 71b4010 | 2016-03-08 15:47:57 -0800 | [diff] [blame] | 176 | GREP_OPTIONS= LC_ALL=C grep @@SANE_TEXT_GREP@@ "$@" |
Junio C Hamano | e1622bf | 2009-11-23 15:56:32 -0800 | [diff] [blame] | 177 | } |
| 178 | |
| 179 | sane_egrep () { |
Junio C Hamano | 71b4010 | 2016-03-08 15:47:57 -0800 | [diff] [blame] | 180 | GREP_OPTIONS= LC_ALL=C egrep @@SANE_TEXT_GREP@@ "$@" |
Junio C Hamano | e1622bf | 2009-11-23 15:56:32 -0800 | [diff] [blame] | 181 | } |
| 182 | |
Junio C Hamano | 4b441f4 | 2007-01-07 02:17:52 -0800 | [diff] [blame] | 183 | is_bare_repository () { |
Junio C Hamano | 5be6007 | 2007-07-02 22:52:14 -0700 | [diff] [blame] | 184 | git rev-parse --is-bare-repository |
Junio C Hamano | 4b441f4 | 2007-01-07 02:17:52 -0800 | [diff] [blame] | 185 | } |
| 186 | |
Junio C Hamano | 9fde940 | 2007-01-12 12:44:08 -0800 | [diff] [blame] | 187 | cd_to_toplevel () { |
Steven Drake | 91dc602 | 2010-01-12 11:34:34 +1300 | [diff] [blame] | 188 | cdup=$(git rev-parse --show-toplevel) && |
| 189 | cd "$cdup" || { |
Vasco Almeida | d323c6b | 2016-06-17 20:21:02 +0000 | [diff] [blame] | 190 | gettextln "Cannot chdir to \$cdup, the toplevel of the working tree" >&2 |
Steven Drake | 91dc602 | 2010-01-12 11:34:34 +1300 | [diff] [blame] | 191 | exit 1 |
| 192 | } |
Junio C Hamano | 9fde940 | 2007-01-12 12:44:08 -0800 | [diff] [blame] | 193 | } |
| 194 | |
Junio C Hamano | e2eb527 | 2011-05-04 19:11:18 -0700 | [diff] [blame] | 195 | require_work_tree_exists () { |
| 196 | if test "z$(git rev-parse --is-bare-repository)" != zfalse |
| 197 | then |
Vasco Almeida | d323c6b | 2016-06-17 20:21:02 +0000 | [diff] [blame] | 198 | program_name=$0 |
Junio C Hamano | acefe2b | 2016-12-20 09:36:23 -0800 | [diff] [blame] | 199 | die "$(eval_gettext "fatal: \$program_name cannot be used without a working tree.")" |
Junio C Hamano | e2eb527 | 2011-05-04 19:11:18 -0700 | [diff] [blame] | 200 | fi |
| 201 | } |
| 202 | |
Shawn O. Pearce | 7eff28a | 2006-12-30 23:32:38 -0500 | [diff] [blame] | 203 | require_work_tree () { |
Vasco Almeida | d323c6b | 2016-06-17 20:21:02 +0000 | [diff] [blame] | 204 | test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true || { |
| 205 | program_name=$0 |
Junio C Hamano | acefe2b | 2016-12-20 09:36:23 -0800 | [diff] [blame] | 206 | die "$(eval_gettext "fatal: \$program_name cannot be used without a working tree.")" |
Vasco Almeida | d323c6b | 2016-06-17 20:21:02 +0000 | [diff] [blame] | 207 | } |
Shawn O. Pearce | 7eff28a | 2006-12-30 23:32:38 -0500 | [diff] [blame] | 208 | } |
| 209 | |
Ramkumar Ramachandra | 92c62a3 | 2010-10-19 20:09:28 +0530 | [diff] [blame] | 210 | require_clean_work_tree () { |
| 211 | git rev-parse --verify HEAD >/dev/null || exit 1 |
| 212 | git update-index -q --ignore-submodules --refresh |
| 213 | err=0 |
| 214 | |
| 215 | if ! git diff-files --quiet --ignore-submodules |
| 216 | then |
Vasco Almeida | d323c6b | 2016-06-17 20:21:02 +0000 | [diff] [blame] | 217 | action=$1 |
| 218 | case "$action" in |
| 219 | rebase) |
| 220 | gettextln "Cannot rebase: You have unstaged changes." >&2 |
| 221 | ;; |
| 222 | "rewrite branches") |
| 223 | gettextln "Cannot rewrite branches: You have unstaged changes." >&2 |
| 224 | ;; |
| 225 | "pull with rebase") |
| 226 | gettextln "Cannot pull with rebase: You have unstaged changes." >&2 |
| 227 | ;; |
| 228 | *) |
| 229 | eval_gettextln "Cannot \$action: You have unstaged changes." >&2 |
| 230 | ;; |
| 231 | esac |
Ramkumar Ramachandra | 92c62a3 | 2010-10-19 20:09:28 +0530 | [diff] [blame] | 232 | err=1 |
| 233 | fi |
| 234 | |
| 235 | if ! git diff-index --cached --quiet --ignore-submodules HEAD -- |
| 236 | then |
Vasco Almeida | d323c6b | 2016-06-17 20:21:02 +0000 | [diff] [blame] | 237 | if test $err = 0 |
Ramkumar Ramachandra | 92c62a3 | 2010-10-19 20:09:28 +0530 | [diff] [blame] | 238 | then |
Vasco Almeida | d323c6b | 2016-06-17 20:21:02 +0000 | [diff] [blame] | 239 | action=$1 |
| 240 | case "$action" in |
| 241 | rebase) |
| 242 | gettextln "Cannot rebase: Your index contains uncommitted changes." >&2 |
| 243 | ;; |
| 244 | "pull with rebase") |
| 245 | gettextln "Cannot pull with rebase: Your index contains uncommitted changes." >&2 |
| 246 | ;; |
| 247 | *) |
| 248 | eval_gettextln "Cannot \$action: Your index contains uncommitted changes." >&2 |
| 249 | ;; |
| 250 | esac |
Ramkumar Ramachandra | 92c62a3 | 2010-10-19 20:09:28 +0530 | [diff] [blame] | 251 | else |
Vasco Almeida | d323c6b | 2016-06-17 20:21:02 +0000 | [diff] [blame] | 252 | gettextln "Additionally, your index contains uncommitted changes." >&2 |
Ramkumar Ramachandra | 92c62a3 | 2010-10-19 20:09:28 +0530 | [diff] [blame] | 253 | fi |
| 254 | err=1 |
| 255 | fi |
| 256 | |
Vasco Almeida | d323c6b | 2016-06-17 20:21:02 +0000 | [diff] [blame] | 257 | if test $err = 1 |
Ramkumar Ramachandra | 92c62a3 | 2010-10-19 20:09:28 +0530 | [diff] [blame] | 258 | then |
Vasco Almeida | d323c6b | 2016-06-17 20:21:02 +0000 | [diff] [blame] | 259 | test -n "$2" && echo "$2" >&2 |
Ramkumar Ramachandra | 92c62a3 | 2010-10-19 20:09:28 +0530 | [diff] [blame] | 260 | exit 1 |
| 261 | fi |
| 262 | } |
| 263 | |
Jeff King | ce80ca5 | 2012-10-18 03:25:22 -0400 | [diff] [blame] | 264 | # Generate a sed script to parse identities from a commit. |
| 265 | # |
| 266 | # Reads the commit from stdin, which should be in raw format (e.g., from |
| 267 | # cat-file or "--pretty=raw"). |
| 268 | # |
| 269 | # The first argument specifies the ident line to parse (e.g., "author"), and |
| 270 | # the second specifies the environment variable to put it in (e.g., "AUTHOR" |
| 271 | # for "GIT_AUTHOR_*"). Multiple pairs can be given to parse author and |
| 272 | # committer. |
| 273 | pick_ident_script () { |
| 274 | while test $# -gt 0 |
| 275 | do |
| 276 | lid=$1; shift |
| 277 | uid=$1; shift |
| 278 | printf '%s' " |
| 279 | /^$lid /{ |
| 280 | s/'/'\\\\''/g |
| 281 | h |
| 282 | s/^$lid "'\([^<]*\) <[^>]*> .*$/\1/'" |
| 283 | s/.*/GIT_${uid}_NAME='&'/p |
| 284 | |
| 285 | g |
| 286 | s/^$lid "'[^<]* <\([^>]*\)> .*$/\1/'" |
| 287 | s/.*/GIT_${uid}_EMAIL='&'/p |
| 288 | |
| 289 | g |
| 290 | s/^$lid "'[^<]* <[^>]*> \(.*\)$/@\1/'" |
| 291 | s/.*/GIT_${uid}_DATE='&'/p |
| 292 | } |
| 293 | " |
| 294 | done |
| 295 | echo '/^$/q' |
| 296 | } |
| 297 | |
| 298 | # Create a pick-script as above and feed it to sed. Stdout is suitable for |
| 299 | # feeding to eval. |
| 300 | parse_ident_from_commit () { |
| 301 | LANG=C LC_ALL=C sed -ne "$(pick_ident_script "$@")" |
| 302 | } |
| 303 | |
| 304 | # Parse the author from a commit given as an argument. Stdout is suitable for |
| 305 | # feeding to eval to set the usual GIT_* ident variables. |
Johannes Schindelin | 0cae234 | 2007-06-25 01:04:11 +0100 | [diff] [blame] | 306 | get_author_ident_from_commit () { |
Johannes Schindelin | 0cae234 | 2007-06-25 01:04:11 +0100 | [diff] [blame] | 307 | encoding=$(git config i18n.commitencoding || echo UTF-8) |
Junio C Hamano | 077b725 | 2008-02-13 13:13:21 -0800 | [diff] [blame] | 308 | git show -s --pretty=raw --encoding="$encoding" "$1" -- | |
Jeff King | ce80ca5 | 2012-10-18 03:25:22 -0400 | [diff] [blame] | 309 | parse_ident_from_commit author AUTHOR |
Johannes Schindelin | 0cae234 | 2007-06-25 01:04:11 +0100 | [diff] [blame] | 310 | } |
| 311 | |
Giuseppe Bilotta | 7d750f0 | 2010-02-25 00:34:16 +0100 | [diff] [blame] | 312 | # Clear repo-local GIT_* environment variables. Useful when switching to |
| 313 | # another repository (e.g. when entering a submodule). See also the env |
| 314 | # list in git_connect() |
| 315 | clear_local_git_env() { |
| 316 | unset $(git rev-parse --local-env-vars) |
| 317 | } |
| 318 | |
Kevin Bracey | 4549162 | 2013-03-13 03:12:21 +0200 | [diff] [blame] | 319 | # Generate a virtual base file for a two-file merge. Uses git apply to |
| 320 | # remove lines from $1 that are not in $2, leaving only common lines. |
| 321 | create_virtual_base() { |
| 322 | sz0=$(wc -c <"$1") |
| 323 | @@DIFF@@ -u -La/"$1" -Lb/"$1" "$1" "$2" | git apply --no-add |
| 324 | sz1=$(wc -c <"$1") |
| 325 | |
| 326 | # If we do not have enough common material, it is not |
| 327 | # worth trying two-file merge using common subsections. |
| 328 | expr $sz0 \< $sz1 \* 2 >/dev/null || : >"$1" |
| 329 | } |
| 330 | |
Johannes Sixt | 87bddba | 2007-11-30 22:06:30 +0100 | [diff] [blame] | 331 | |
Junio C Hamano | 10587ce | 2012-05-16 10:36:01 -0700 | [diff] [blame] | 332 | # Platform specific tweaks to work around some commands |
Johannes Sixt | 87bddba | 2007-11-30 22:06:30 +0100 | [diff] [blame] | 333 | case $(uname -s) in |
| 334 | *MINGW*) |
| 335 | # Windows has its own (incompatible) sort and find |
| 336 | sort () { |
| 337 | /usr/bin/sort "$@" |
| 338 | } |
| 339 | find () { |
| 340 | /usr/bin/find "$@" |
| 341 | } |
Ramsay Jones | be39048 | 2012-04-17 19:48:39 +0100 | [diff] [blame] | 342 | # git sees Windows-style pwd |
| 343 | pwd () { |
| 344 | builtin pwd -W |
| 345 | } |
Pat Thoyts | 5e9677c | 2010-09-30 14:24:07 +0100 | [diff] [blame] | 346 | is_absolute_path () { |
| 347 | case "$1" in |
| 348 | [/\\]* | [A-Za-z]:*) |
| 349 | return 0 ;; |
| 350 | esac |
| 351 | return 1 |
| 352 | } |
Johannes Sixt | 87bddba | 2007-11-30 22:06:30 +0100 | [diff] [blame] | 353 | ;; |
Pat Thoyts | 5e9677c | 2010-09-30 14:24:07 +0100 | [diff] [blame] | 354 | *) |
| 355 | is_absolute_path () { |
| 356 | case "$1" in |
| 357 | /*) |
| 358 | return 0 ;; |
| 359 | esac |
| 360 | return 1 |
| 361 | } |
Johannes Sixt | 87bddba | 2007-11-30 22:06:30 +0100 | [diff] [blame] | 362 | esac |
Junio C Hamano | 10587ce | 2012-05-16 10:36:01 -0700 | [diff] [blame] | 363 | |
| 364 | # Make sure we are in a valid repository of a vintage we understand, |
| 365 | # if we require to be in a git repository. |
David Aguilar | 1c7e2d2 | 2014-10-11 01:39:36 -0700 | [diff] [blame] | 366 | git_dir_init () { |
Junio C Hamano | 10587ce | 2012-05-16 10:36:01 -0700 | [diff] [blame] | 367 | GIT_DIR=$(git rev-parse --git-dir) || exit |
| 368 | if [ -z "$SUBDIRECTORY_OK" ] |
| 369 | then |
| 370 | test -z "$(git rev-parse --show-cdup)" || { |
| 371 | exit=$? |
Vasco Almeida | d323c6b | 2016-06-17 20:21:02 +0000 | [diff] [blame] | 372 | gettextln "You need to run this command from the toplevel of the working tree." >&2 |
Junio C Hamano | 10587ce | 2012-05-16 10:36:01 -0700 | [diff] [blame] | 373 | exit $exit |
| 374 | } |
| 375 | fi |
| 376 | test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || { |
Vasco Almeida | d323c6b | 2016-06-17 20:21:02 +0000 | [diff] [blame] | 377 | gettextln "Unable to determine absolute path of git directory" >&2 |
Junio C Hamano | 10587ce | 2012-05-16 10:36:01 -0700 | [diff] [blame] | 378 | exit 1 |
| 379 | } |
LE Manh Cuong | 01247e0 | 2016-06-19 03:26:03 +0700 | [diff] [blame] | 380 | : "${GIT_OBJECT_DIRECTORY="$(git rev-parse --git-path objects)"}" |
David Aguilar | 1c7e2d2 | 2014-10-11 01:39:36 -0700 | [diff] [blame] | 381 | } |
| 382 | |
| 383 | if test -z "$NONGIT_OK" |
| 384 | then |
| 385 | git_dir_init |
Junio C Hamano | 10587ce | 2012-05-16 10:36:01 -0700 | [diff] [blame] | 386 | fi |
Ramkumar Ramachandra | bac1ddd | 2013-06-14 18:47:51 +0530 | [diff] [blame] | 387 | |
| 388 | peel_committish () { |
| 389 | case "$1" in |
| 390 | :/*) |
| 391 | peeltmp=$(git rev-parse --verify "$1") && |
| 392 | git rev-parse --verify "${peeltmp}^0" |
| 393 | ;; |
| 394 | *) |
| 395 | git rev-parse --verify "${1}^0" |
| 396 | ;; |
| 397 | esac |
| 398 | } |